function xbXMLDocument(namespaceURI, nodeName, doctype)
{
    this.doc = null;
    this.isDocument = false;
    this.nodes = new Array();
    if (namespaceURI == "isDocument") {
        this.doc = document;
        this.isDocument = true;
        return;
    }

	if (typeof(ActiveXObject) == 'function')
    {
        var eError;

        if (!namespaceURI)
            namespaceURI = null;

        if (!doctype)
            doctype = null;

        this.doc = new ActiveXObject('MSXML2.DOMDocument.4.0');
        if (this.doc)
        {
            this.doc.appendChild(this.doc.createElement(nodeName));
            //doc.namespaceURI = namespaceURI;
            //doc.doctype = doctype;
        }

    }

}
xbXMLDocument.prototype = {

	nodeWrapperFactory:function(node) {
		if (!node)
		{
			return null;
		}
		if (node.nodeType == 1) {
			var bxe_id = node.getAttribute("bxe_id");
		}
		if (bxe_id && this.nodes[bxe_id] && this.nodes[bxe_id].className ==  "XMLNodeWrapper") {
			return this.nodes[bxe_id];
		} else {
			this.nodes[bxe_id] = new XMLNodeWrapper(node,this);
			return this.nodes[bxe_id];
		}

	},

	getElementsByTagName:function(name) {
	
			var nodes = this.doc.getElementsByTagName(name);
			var nodesWrapper = new Array();
			for (var i = 0; i < nodes.length; i++)
			{
				nodesWrapper[i] = this.nodeWrapperFactory(nodes[i]);
			}

			return nodesWrapper;
	},

	getElementsByTagNameNS:function(uri,name) {

			var nodes = this.doc.getElementsByTagName(name);
			var nodesWrapper = new Array();
			for (var i = 0; i < nodes.length; i++)
			{
				nodesWrapper[i] = new XMLNodeWrapper(nodes[i],this);
			}

			return nodesWrapper;
	},
	getElementById:function (id) {
		var bl = this.nodeWrapperFactory(this.doc.getElementById(id));
		return bl;
	},
	importNode:function(importedNode,deep) {
				
		if (this.isDocument) {
			if (importedNode.node.nodeType == 1) {
				var newNode = this.createElementInHTML(importedNode.node.nodeName,importedNode.namespaceURI);
			}
			else {
				var newNode = this.createNode(importedNode.node.nodeType,importedNode.node.nodeName,importedNode.node.nodeValue,"");
			}

			if (importedNode.node.nodeType == 1)
			{
				var attr;
				for (i = 0; i < importedNode.node.attributes.length; i++)
				{
					/*attr = importedNode.node.attributes.item(i).importNode(deep);
					importedNode.node.attributes.setNamedItem(attr);*/
					importedNode.node.setAttribute(importedNode.node.attributes.item(i).nodeName,importedNode.node.attributes.item(i).value);
				}
			}

			if (deep)
			{
				var tmpChild = this.nodeWrapperFactory(importedNode.node.firstChild);
				var childNode;

				while (tmpChild)
				{

					childNode = tmpChild.cloneNode(deep);

					newNode.appendChild(childNode);
					tmpChild = this.nodeWrapperFactory(tmpChild.node.nextSibling);
				}
			}
			return newNode;
		}

	},
	createNode:function(nodeType,nodeName,nodeValue,nodeNamespace) {
		if (this.isDocument && nodeType == 1)
		{
			return this.doc.createElement(nodeName);
		}
		else if (this.isDocument && nodeType == 3) {
			return this.nodeWrapperFactory(this.doc.createTextNode(nodeValue.replace(/\s{2,}/g," ")));
		}
		else if (this.isDocument && nodeType == 8) {
					return this.nodeWrapperFactory(this.doc.createComment(nodeValue.replace(/\s{2,}/g," ")));
				}
		
		else {
		
			return this.nodeWrapperFactory(this.doc.createNode(nodeType,nodeName,nodeNamespace));
		}
	},

	createElement:function(nodeName) {
		return this.nodeWrapperFactory(this.doc.createElement(nodeName));
	},

	createElementInHTML:function(nodeName,nodeNamespaceURI) {
		if (!this.isDocument) {
			return this.createElement(nodeName);
		}
		else {
			if (nodeNamespaceURI == "http://www.w3.org/1999/xhtml") {
					var newNode = this.createElement(nodeName);
			} else {
					var newNode = this.createElement("span");
					newNode.node.className = nodeName.replace(/:/,"_");
			}

		return newNode;
		}
	}
}
function XMLNodeWrapper(node,docu) {

	this.node = node;
	this.ownerDocument = docu;
	this.bxe_id = bxe_id++;
	if (node.nodeType == 1 && !node.getAttribute("bxe_id"))
	{
		node.setAttribute("bxe_id",this.bxe_id);
	}
	//this.parentNode = node.parentNode;

	this.className = "XMLNodeWrapper";
	if (this.node && this.node.ownerDocument == document) {
		this.isDocument = true;
	}
}


XMLNodeWrapper.prototype = {

   cloneNode:function (deep) {
	   if (this.node.nodeType == 1) {
	   	   var newNode = this.getOwnerDocument().createElementInHTML(this.node.nodeName,this.node.namespaceURI);
	   var attr;

	   	   for (i = 0; i < this.node.attributes.length; i++)
	   	   {
	   		   /*attr = importedNode.node.attributes.item(i).importNode(deep);
	   		   importedNode.node.attributes.setNamedItem(attr);*/
	   		   if (this.node.attributes.item(i).nodeName != "bxe_id" ){
	   		   newNode.node.setAttribute(this.node.attributes.item(i).nodeName,this.node.attributes.item(i).value);
	   		}
	   }
	   }
	   else {
	   		   var newNode = this.getOwnerDocument().createNode(this.node.nodeType,this.node.nodeName,this.node.nodeValue,"");
	   }


	   if (deep)
	   {
		   var tmpChild = this.getOwnerDocument().nodeWrapperFactory(this.node.firstChild);

		   var childNode;

		   while (tmpChild)
		   {
			   childNode = tmpChild.cloneNode(deep);
			   newNode.node.appendChild(childNode.node);
			   tmpChild =  this.getOwnerDocument().nodeWrapperFactory(tmpChild.node.nextSibling);
		   }
	   }


	   return newNode;
   },

   xml:function() {
	   return this.node.xml;
   },
   appendChild:function(childNode) {
	   return this.getOwnerDocument().nodeWrapperFactory(this.node.appendChild(childNode.node));
   },

   getOwnerDocument:function() {
	   return this.ownerDocument;
   }
}
